package weaver.formmode.recruit.modeexpand.position;

import com.alibaba.fastjson.JSON;
import com.engine.recruit.entity.position.PositionSdkInstance;
import com.weaver.rpa.sdk.clients.application.resume.ERPAResumeSDKClient;
import com.weaver.rpa.sdk.clients.application.resume.entity.ResumeJobV2Dto;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import weaver.conn.RecordSet;
import weaver.formmode.customjavacode.AbstractModeExpandJavaCodeNew;
import weaver.formmode.recruit.modeexpand.util.RecruitPositionUtil;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.soa.workflow.request.MainTableInfo;
import weaver.soa.workflow.request.Property;
import weaver.soa.workflow.request.RequestInfo;

import java.util.HashMap;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2024/05/29
 * @version: 1.0
 */
public class SyncPositionModeExpand extends AbstractModeExpandJavaCodeNew {

    @Override
    public Map<String, String> doModeExpand(Map<String, Object> param) {
        String tableName = "uf_jcl_zp_zpzw";

        Map<String, String> resultMap = new HashMap<>(16);
        boolean enableSdkClient = PositionSdkInstance.enableSdkClient();
        if (!enableSdkClient) {
            return resultMap;
        }
        BaseBean baseBean = new BaseBean();
        try {
            User user = (User) param.get("user");
            int billId;
            int modeId;
            RequestInfo requestInfo = (RequestInfo) param.get("RequestInfo");
            if (requestInfo != null) {
                billId = Util.getIntValue(requestInfo.getRequestid());
                modeId = Util.getIntValue(requestInfo.getWorkflowid());
                if (billId > 0 && modeId > 0) {
                    long jobId = -1;
                    RecordSet rs = new RecordSet();
                    rs.executeQuery("select qllgwid from " + tableName + " where id = ?", billId);
                    if (rs.next()) {
                        String qllgwid = rs.getString("qllgwid");
                        if (StringUtils.isNotBlank(qllgwid)) {
                            jobId = Long.parseLong(qllgwid);
                        }
                    }
                    ERPAResumeSDKClient client = PositionSdkInstance.getPositionSdkInstance().getResumeSDKClient();
                    Map<String, Object> map = new HashMap<>(16);
                    MainTableInfo mainTableInfo = requestInfo.getMainTableInfo();
                    Property[] properties = mainTableInfo.getProperty();
                    for (Property property : properties) {
                        map.put(property.getName(), property.getValue());
                    }
                    ResumeJobV2Dto resumeJobDto = RecruitPositionUtil.convertMap2ResumeJobV2Dto(user, map);
                    String userId = String.valueOf(user.getUID());
                    // 未创建职位，则先创建职位
                    if (jobId == -1) {
                        baseBean.writeLog("【创建职位】,[id=" + billId + "],resumeJobDto=" + JSON.toJSONString(resumeJobDto));
                        // 创建千里聆职位
                        jobId = client.addResumeJobV2(userId, resumeJobDto);
                        // 更新千里聆ID到建模表单
                        rs.executeUpdate("update " + tableName + " set qllgwid = ? where id = ?", jobId, billId);
                    } else {
                        baseBean.writeLog("【更新职位】,[id=" + billId + "],[qllgwid=" + jobId + "],resumeJobDto=" + JSON.toJSONString(resumeJobDto));
                        // 已发布的职位，更新职位信息
                        client.editResumeJobV2(userId, jobId, jobDto -> {
                            new BaseBean().writeLog("职位更新前：" + JSON.toJSONString(jobDto));
                            BeanUtils.copyProperties(resumeJobDto, jobDto);
                            new BaseBean().writeLog("职位更新后：" + JSON.toJSONString(jobDto));
                        });
                    }

                }
            }
        } catch (Exception e) {
            baseBean.writeLog(e);
            resultMap.put("errmsg", "招聘职位同步千里聆失败！" + e.getMessage());
            resultMap.put("flag", "false");
        }
        return resultMap;
    }

}
